<app-header-catalog
  [catalog]="'mapset'"
  [label]="label"
  [description]="description"
  [breadcrumb]="breadcrumb"
/>

<div [ngClass]="['mapset-page', jds.mt(30), jds.mb(70), jds.mx(0)]">
  <div [ngClass]="jds.container">
    <div [ngClass]="jds.row">
      <aside [ngClass]="[jds.col(3)]">
        <jds-bi-accordion
          #acc="jdsBiAccordion"
          [destroyOnHide]="false"
          [closeOthers]="false"
          [activeIds]="[
            'accordion-organization',
            'accordion-topic',
            'accordion-mapset-type',
            'accordion-classification'
          ]"
          [colorScheme]="colorScheme"
        >
          <!-- Filter Organization Satu Peta -->
          <jds-bi-panel
            id="accordion-organization"
            title="Organisasi"
          >
            <ng-template jdsBiPanelContent>
              @if (vm.listOrganizationSatuPeta(); as listOrgSatuPeta) {
                @switch (listOrgSatuPeta.status) {
                  @case ('loading') {
                    <app-skeleton-filter />
                  }
                  @case ('success') {
                    <app-filter-organization
                      [data]="listOrgSatuPeta.data.list"
                      [filter]="vm.filterOrganization()"
                      (filterChange)="vm.handleFilterOrganization($event)"
                    />
                  }
                }
              }
            </ng-template>
          </jds-bi-panel>

          <!-- Filter Topic Satu Peta -->
          <jds-bi-panel
            id="accordion-topic"
            title="Topik"
          >
            <ng-template jdsBiPanelContent>
              @if (vm.listTopicSatuPeta(); as listTopicSatuPeta) {
                @switch (listTopicSatuPeta.status) {
                  @case ('loading') {
                    <app-skeleton-filter />
                  }
                  @case ('success') {
                    <app-filter-topic
                      [data]="listTopicSatuPeta.data.list"
                      [filter]="vm.filterTopic()"
                      (filterChange)="vm.handleFilterTopic($event)"
                    />
                  }
                }
              }
            </ng-template>
          </jds-bi-panel>

          <!-- Filter Mapset Type -->
          <jds-bi-panel
            id="accordion-mapset-type"
            title="Tipe Peta"
          >
            <ng-template jdsBiPanelContent>
              @if (vm.listMapsetType(); as listMapsetType) {
                @switch (listMapsetType.status) {
                  @case ('loading') {
                    <app-skeleton-filter />
                  }
                  @case ('success') {
                    <app-filter-mapset-type
                      [data]="listMapsetType.data.list"
                      [filter]="vm.filterType()"
                      (filterChange)="vm.handleFilterMapsetType($event)"
                    />
                  }
                }
              }
            </ng-template>
          </jds-bi-panel>

          <!-- Filter Classification Dataset -->
          <jds-bi-panel
            id="accordion-classification"
            title="Klasifikasi"
          >
            <ng-template jdsBiPanelContent>
              @if (vm.listClassification(); as listClass) {
                @switch (listClass.status) {
                  @case ('loading') {
                    <app-skeleton-filter />
                  }
                  @case ('success') {
                    <app-filter-classification
                      [data]="listClass.data.list"
                      [filter]="vm.filterClassification()"
                      (filterChange)="vm.handleFilterClassification($event)"
                    />
                  }
                }
              }
            </ng-template>
          </jds-bi-panel>
        </jds-bi-accordion>
      </aside>

      <div [ngClass]="[jds.col(9)]">
        <!-- Search Catalog -->
        <div [ngClass]="[jds.mb(16)]">
          <app-search-catalog
            [catalog]="'mapset'"
            [search]="vm.filterSearch()"
            (searchChange)="vm.handleFilterSearch($event)"
          />
        </div>

        <div
          [ngClass]="[
            jds.d('flex'),
            jds.alignItems('center'),
            jds.justifyContent('between'),
            jds.mb(24)
          ]"
        >
          <!-- Suggestion Catalog -->
          @if (vm.listMapset(); as listMapset) {
            @switch (listMapset.status) {
              @case ('loading') {
                <div class="wrapper-skeleton">
                  <ngx-skeleton-loader
                    [theme]="{
                      width: '25%',
                      'border-radius': '0',
                      height: '22px',
                      'margin-bottom': '0'
                    }"
                  />
                </div>
              }
              @case ('success') {
                @if (listMapset.data.list.length > 0) {
                  <span [ngClass]="[jds.fs(14)]">
                    <strong>
                      {{
                        listMapset.data.pagination.total_items
                          | number: '1.0-0' : 'id'
                      }}
                    </strong>
                    Mapset ditemukan
                  </span>
                } @else {
                  <span [ngClass]="[jds.fs(14)]"> Mapset tidak ditemukan </span>
                }
              }
            }
          }

          <!-- Sort Catalog -->
          <app-sort-catalog
            [catalog]="'mapset'"
            [sort]="vm.filterSort()"
            (sortChange)="vm.handleFilterSort($event)"
          />
        </div>

        <!-- Quick Access Catalog -->
        @if (vm.hasFilterQuickAccess()) {
          <div [ngClass]="[vm.hasFilterQuickAccess() ? jds.mb(16) : '']">
            <div [ngClass]="jds.d('flex')">
              <div
                [style.minWidth.px]="100"
                [style.lineHeight.px]="32"
              >
                <span>Filter Aktif: </span>
              </div>
              <div>
                <!-- Quick Access Organization -->
                @if (vm.listOrganizationSatuPeta(); as listOrgSatuPeta) {
                  @if (listOrgSatuPeta.isSuccess) {
                    <app-quick-access-catalog
                      [type]="'organization'"
                      [data]="listOrgSatuPeta.data.list"
                      [filter]="vm.filterOrganization()"
                      (filterChange)="vm.handleFilterOrganization($event)"
                    />
                  }
                }

                <!-- Quick Access Topic -->
                @if (vm.listTopicSatuPeta(); as listTopicSatuPeta) {
                  @if (listTopicSatuPeta.isSuccess) {
                    <app-quick-access-catalog
                      [type]="'topic'"
                      [data]="listTopicSatuPeta.data.list"
                      [filter]="vm.filterTopic()"
                      (filterChange)="vm.handleFilterTopic($event)"
                    />
                  }
                }

                <!-- Quick Access Mapset Type -->
                @if (vm.listMapsetType(); as listMapsetType) {
                  @if (listMapsetType.isSuccess) {
                    <app-quick-access-catalog
                      [type]="'mapset-type'"
                      [data]="listMapsetType.data.list"
                      [filter]="vm.filterType()"
                      (filterChange)="vm.handleFilterMapsetType($event)"
                    />
                  }
                }

                <!-- Quick Access Classification -->
                @if (vm.listClassification(); as listClass) {
                  @if (listClass.isSuccess) {
                    <app-quick-access-catalog
                      [type]="'classification'"
                      [data]="listClass.data.list"
                      [filter]="vm.filterClassification()"
                      (filterChange)="vm.handleFilterClassification($event)"
                    />
                  }
                }

                <button
                  [size]="'sm'"
                  [ngClass]="[jds.me(8), jds.mb(8)]"
                  [variant]="'ghost'"
                  [colorScheme]="colorScheme"
                  (click)="vm.handleFilterClear()"
                  jdsBiButton
                  type="button"
                >
                  Hapus Semua
                </button>
              </div>
            </div>
          </div>
        }

        <!-- List Catalog Mapset -->
        @if (vm.listMapset(); as listMapset) {
          @switch (listMapset.status) {
            @case ('loading') {
              <app-skeleton-catalog />
            }
            @case ('success') {
              @if (listMapset.isFetching) {
                <app-skeleton-catalog />
              } @else if (listMapset.data.list.length > 0) {
                @for (item of listMapset.data.list; track item.id) {
                  <app-list-mapset
                    [isAction]="false"
                    [data]="item"
                  />
                }

                <jds-bi-pagination
                  [colorScheme]="colorScheme"
                  [perPageItems]="perPageItems"
                  [pagination]="listMapset.data.pagination"
                  [perPage]="vm.filterPerPage()"
                  [page]="vm.filterCurrentPage()"
                  (filterPerPage)="vm.handleFilterPerPage($event)"
                  (filterPage)="vm.handleFilterCurrentPage($event)"
                />
              } @else {
                @if (vm.hasFilterSearch()) {
                  <app-list-empty type="dataset">
                    <h6>Maaf, hasil pencarian tidak ditemukan.</h6>
                    <p>
                      Mapset yang Anda cari tidak ditemukan atau terjadi
                      kesalahan penulisan kata kunci.
                    </p>
                  </app-list-empty>
                } @else {
                  <app-list-empty type="dataset">
                    <h6>Maaf, belum ada Mapset yang dapat diakses.</h6>
                    <p>
                      Mohon coba kembali di lain waktu untuk mendapatkan Mapset
                      yang Anda cari.
                    </p>
                  </app-list-empty>
                }
              }
            }
          }
        }
      </div>
    </div>
  </div>
</div>
